<html>
<head>
<title>OGRE: OgreCodec.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreCodec.h</h1><a href="OgreCodec_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef _Codec_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define _Codec_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgreSharedPtr_8h.html">OgreSharedPtr.h</a>"</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreDataStream_8h.html">OgreDataStream.h</a>"</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>"</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include "<a class="code" href="OgreStringVector_8h.html">OgreStringVector.h</a>"</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00039"></a>00039 
<a name="l00049"></a><a class="code" href="classOgre_1_1Codec.html">00049</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Codec.html" title="Abstract class that defines a &amp;#39;codec&amp;#39;.">Codec</a>
<a name="l00050"></a>00050     {
<a name="l00051"></a>00051     <span class="keyword">protected</span>:
<a name="l00052"></a><a class="code" href="classOgre_1_1Codec.html#6359075bde4a8d569b9b8ce66672e7da">00052</a>         <span class="keyword">typedef</span> std::map&lt; String, Codec* &gt; CodecList; 
<a name="l00055"></a><a class="code" href="classOgre_1_1Codec.html#715604fe2fb727a6aa4f1e9c9364f870">00055</a>         <span class="keyword">static</span> CodecList ms_mapCodecs;
<a name="l00056"></a>00056 
<a name="l00057"></a>00057     <span class="keyword">public</span>:
<a name="l00058"></a><a class="code" href="classOgre_1_1Codec_1_1CodecData.html">00058</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#f4c2f5df97e3050dd5266408be42db4b">_OgrePrivate</a> <a class="code" href="classOgre_1_1Codec_1_1CodecData.html">CodecData</a> 
<a name="l00059"></a>00059         {
<a name="l00060"></a>00060         <span class="keyword">public</span>:
<a name="l00061"></a><a class="code" href="classOgre_1_1Codec_1_1CodecData.html#8d1d3dc4a466a4e992aad72c14bf81eb">00061</a>             <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1Codec_1_1CodecData.html">CodecData</a>() {};
<a name="l00062"></a>00062 
<a name="l00065"></a><a class="code" href="classOgre_1_1Codec_1_1CodecData.html#b2681263d0b7dafe3ff0afba729eeef4">00065</a>             <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> dataType()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="stringliteral">"CodecData"</span>; };
<a name="l00066"></a>00066         };
<a name="l00067"></a><a class="code" href="classOgre_1_1Codec.html#29e31ad112b08ea7fb648b63f426ff1f">00067</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr&lt;CodecData&gt;</a> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">CodecDataPtr</a>;
<a name="l00068"></a>00068 
<a name="l00069"></a><a class="code" href="classOgre_1_1Codec.html#21f4b8a16d070793d576f827c9fee218">00069</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Wraps iteration over a const map.">ConstMapIterator&lt;CodecList&gt;</a> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Wraps iteration over a const map.">CodecIterator</a>;
<a name="l00070"></a>00070 
<a name="l00071"></a>00071     <span class="keyword">public</span>:
<a name="l00072"></a>00072         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1Codec.html" title="Abstract class that defines a &amp;#39;codec&amp;#39;.">Codec</a>();
<a name="l00073"></a>00073         
<a name="l00076"></a><a class="code" href="classOgre_1_1Codec.html#60f445cc6919df56af6611fd14eec47d">00076</a>         <span class="keyword">static</span> <span class="keywordtype">void</span> registerCodec( <a class="code" href="classOgre_1_1Codec.html" title="Abstract class that defines a &amp;#39;codec&amp;#39;.">Codec</a> *pCodec )
<a name="l00077"></a>00077         {
<a name="l00078"></a>00078             ms_mapCodecs[pCodec-&gt;<a class="code" href="classOgre_1_1Codec.html#da1a5477ab6a563565f1b3599d7b806a" title="Returns the type of the codec as a String.">getType</a>()] = pCodec;
<a name="l00079"></a>00079         }
<a name="l00080"></a>00080 
<a name="l00083"></a><a class="code" href="classOgre_1_1Codec.html#c1199a6638ff560aa81287cd12c26bcf">00083</a>         <span class="keyword">static</span> <span class="keywordtype">void</span> unRegisterCodec( <a class="code" href="classOgre_1_1Codec.html" title="Abstract class that defines a &amp;#39;codec&amp;#39;.">Codec</a> *pCodec )
<a name="l00084"></a>00084         {
<a name="l00085"></a>00085             ms_mapCodecs.erase(pCodec-&gt;<a class="code" href="classOgre_1_1Codec.html#da1a5477ab6a563565f1b3599d7b806a" title="Returns the type of the codec as a String.">getType</a>());
<a name="l00086"></a>00086         }
<a name="l00087"></a>00087 
<a name="l00089"></a><a class="code" href="classOgre_1_1Codec.html#55bf1d49e91958f8e412a583666bbd58">00089</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Wraps iteration over a const map.">CodecIterator</a> getCodecIterator(<span class="keywordtype">void</span>)
<a name="l00090"></a>00090         {
<a name="l00091"></a>00091             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Wraps iteration over a const map.">CodecIterator</a>(ms_mapCodecs.begin(), ms_mapCodecs.end());
<a name="l00092"></a>00092         }
<a name="l00093"></a>00093 
<a name="l00095"></a>00095         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#783e5227595f351519627abfb740ec85">StringVector</a> getExtensions(<span class="keywordtype">void</span>);
<a name="l00096"></a>00096 
<a name="l00098"></a>00098         <span class="keyword">static</span> <a class="code" href="classOgre_1_1Codec.html" title="Abstract class that defines a &amp;#39;codec&amp;#39;.">Codec</a>* getCodec(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; extension);
<a name="l00099"></a>00099 
<a name="l00103"></a>00103         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">DataStreamPtr</a> code(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">MemoryDataStreamPtr</a>&amp; input, CodecDataPtr&amp; pData) <span class="keyword">const</span> = 0;
<a name="l00111"></a>00111         <span class="keyword">virtual</span> <span class="keywordtype">void</span> codeToFile(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">MemoryDataStreamPtr</a>&amp; input, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; outFileName, CodecDataPtr&amp; pData) <span class="keyword">const</span> = 0;
<a name="l00112"></a>00112 
<a name="l00114"></a><a class="code" href="classOgre_1_1Codec.html#8cc81c85bd7d4e25393aa153c5e01454">00114</a>         <span class="keyword">typedef</span> std::pair&lt;MemoryDataStreamPtr, CodecDataPtr&gt; DecodeResult;
<a name="l00120"></a>00120         <span class="keyword">virtual</span> DecodeResult decode(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">DataStreamPtr</a>&amp; input) <span class="keyword">const</span> = 0;
<a name="l00121"></a>00121 
<a name="l00124"></a>00124         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> getType() <span class="keyword">const</span> = 0;
<a name="l00125"></a>00125 
<a name="l00128"></a>00128         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> getDataType() <span class="keyword">const</span> = 0;
<a name="l00129"></a>00129     };
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 } <span class="comment">// namespace</span>
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:49 2008
</p>
</body>
</html>
